# -*- coding: utf_8 -*-
import pickle
from direct.showbase.DirectObject import DirectObject
from pandac.PandaModules import Vec3
from direct.gui.OnscreenText import OnscreenText

class AI(DirectObject):
    def __init__(self,rootNode):
        apath = 'ai/test.path'
        if base.appRunner:
            apath = base.appRunner.multifileRoot + '/' + apath
        self.path=self.loadPath(apath)   
        self.cars=[]
        self.wps={}
        self.AIMaxSpeed={}
        self.rootNode=rootNode
        #taskMgr.add(self.AITask,"AITask")
        taskMgr.doMethodLater(0.2,self.AITask,"AITask")
        taskMgr.doMethodLater(0.2,self.selWPTask,"selWPTask")        
        self.helper=loader.loadModel("res/models/box")
        self.helper.reparentTo(self.rootNode)
        self.infoText = OnscreenText(text = '0', pos = (-0.9, 0.9), scale = 0.07, mayChange=1)
    def loadPath(self,fn):
        f=open(fn,"r")
        res=pickle.load(f)
        f.close()
        return res
    
    def selWPTask(self, task):
        for car in self.cars:
            p=car.box.getPos()
            dist=1000000
            index=self.wps[car.name]
            i=0
            for t in self.path:
                tx,ty,tz=t                
                v=Vec3(tx,ty,tz)-p
                if v.length()<dist:
                    dist=v.length()
                    index=i
                i=i+1
            if index<len(self.path)-2:
                tx,ty,tz=self.path[index]
                tx2,ty2,tz2=self.path[index+1]
                dd=Vec3(Vec3(tx2,ty2,tz2)-Vec3(tx,ty,tz)).length()
                if dd>Vec3(Vec3(tx2,ty2,tz2)-p).length():                        
                    #nextpoint=self.path[index+1]
                    index=index+1
                else:
                    if Vec3(Vec3(tx,ty,tz)-p).length()<150:
                    #    nextpoint=self.path[index]
                    #else:
                    #    nextpoint=self.path[index+1]
                        index=index+1
            else:
                tx,ty,tz=self.path[index]
                tx2,ty2,tz2=self.path[0]
                dd=Vec3(Vec3(tx2,ty2,tz2)-Vec3(tx,ty,tz)).length()
                if dd>Vec3(Vec3(tx2,ty2,tz2)-p).length():                    
                    #nextpoint=self.path[0]
                    index=0
                else:
                    if Vec3(Vec3(tx,ty,tz)-p).length()<150:
                    #    nextpoint=self.path[index]
                    #else:
                    #    nextpoint=self.path[0]
                        index=0
            self.wps[car.name]=index
        return task.again
    
    def AITask(self,task):
        for car in self.cars:
            p=car.box.getPos()
            tx,ty,tz=self.path[self.wps[car.name]]
            self.helper.setPos(tx,ty,tz+10)
            #direct=Vec3(Vec3(tx,ty,p.getZ())-p)
            rp=car.box.getRelativePoint(self.rootNode,Vec3(tx,ty,p.getZ()))
            direct=rp
            direct.normalize()
            ad=Vec3(direct).angleDeg(Vec3(0,1,0))
            ar=Vec3(direct).angleRad(Vec3(0,1,0))
            #print index, ad
            #self.infoText.setText(str(ad)+" "+str(car.acceleration))
            linearvel=car.body.getLinearVel().length()*0.1
            if linearvel==0:
                linearvel=1
            #car.maxSpeed=55
            self.AIMaxSpeed[car.name]=55
            if ad>15:
                self.AIMaxSpeed[car.name]=30
            if ad>35:
                self.AIMaxSpeed[car.name]=20
            if ad>50:
                self.AIMaxSpeed[car.name]=10
            if ad<90:
                car.Accel(0, 0,[1,3,0,2])
                car.Turn(False,0)                
                if ad>5/Vec3(rp).length():
                    if (rp.getX()*car.carOrientation)>0:
                        if abs(car.turnangle)<ar:
                            car.Turn(True,ad*0.0005/linearvel)
                    else:
                        if abs(car.turnangle)<ar:
                            car.Turn(True,-ad*0.0005/linearvel)     

                if car.body.getLinearVel().length()>self.AIMaxSpeed[car.name]:
                    if car.acceleration==True:
                        car.acceleration=False
                        #car.Accel(0, 10,[1,3,0,2])
                else:
                    if car.acceleration==False:
                        car.acceleration=True
                        #car.Accel(0, 0,[1,3,0,2])
            else:
                car.Turn(False,0)                
                if ad>5/Vec3(rp).length():
                    if (rp.getX()*car.carOrientation)>0:
                        if abs(car.turnangle)<ar:
                            car.Turn(True,-ad*0.0005/linearvel)
                    else:
                        if abs(car.turnangle)<ar:
                            car.Turn(True,ad*0.0005/linearvel)                     
                car.acceleration=False
                car.Accel(-25, 40,[1,3])
        #return task.again
        return task.cont
    
    def addCar(self,car):
        car.maxSpeed=50
        self.cars.append(car)
        self.wps[car.name]=0
        self.AIMaxSpeed[car.name]=0
