# -*- coding: utf_8 -*-
from pandac.PandaModules import *

class ODEWorld():
    def __init__(self,render):
        

        #Освещение
        #lights
        self.ambientLight = render.attachNewNode( AmbientLight( "ambientLight" ) )
        self.ambientLight.node().setColor( Vec4( .8, .8, .8, 1 ) )
        self.PointLight = camera.attachNewNode( PointLight( "PointLight" ) )
        self.PointLight.node().setColor( Vec4( 0.8, 0.8, 0.8, 1 ) )
        self.PointLight.node().setAttenuation( Vec3( .1, 0.04, 0.0 ) ) 
        render.setLight( self.ambientLight )
        render.setLight( self.PointLight )
       
        #Установка нашего физического мира
        #set physic world
        self.world = OdeWorld()
        self.world.setGravity(0, 0, -9.81)
        #Настройка взаимодействующих поверхностей
        #Adjustment of interaction surfaces
        self.world.initSurfaceTable(5)
        # (surfaceId1, surfaceId2, mu, bounce, bounce_vel, soft_erp, soft_cfm, slip, dampen)
        self.world.setSurfaceEntry(0, 0, 0.8, 0.0, 10    , 0.9, 0.00001, 100, 0.002)
        self.world.setSurfaceEntry(0, 1, 1.0, 0.1, 10, 0.8, 0.00005, 0, 1)        
        self.world.setSurfaceEntry(0, 2, 1.2, 0.1, 10, 0.8, 0.00005, 0, 1)        
        self.world.setSurfaceEntry(3, 1, 0.4, 0.2, 10, 0.7, 0.00005, 0, 1)        
        self.world.setSurfaceEntry(3, 2, 0.4, 0.2, 10, 0.7, 0.00005, 0, 1)        
        self.world.setSurfaceEntry(4, 1, 0.8, 0.2, 10, 0.7, 0.00005, 0, 1)        
        self.world.setSurfaceEntry(4, 2, 1.0, 0.2, 10, 0.7, 0.00005, 0, 1)                
        #Создание пространства ОДЕ и добавление контактной группы для хранения
        #соединений, возникших при столкновении
        #Create ODE space; add contact group for store contact joints
        self.space = OdeSimpleSpace()
        self.space.setAutoCollideWorld(self.world)
        self.contactgroup = OdeJointGroup()
        self.space.setAutoCollideJointGroup(self.contactgroup)
        self.world.setQuickStepNumIterations(10)
        
##        #Создаём образец бокса для копирования
##        #Create basic box for copy later
##        box = loader.loadModel("res/models/box")
##        tex = loader.loadTexture('res/textures/box.png')
##        ts = TextureStage('ts')
##        ts.setMode(TextureStage.MModulate)
##        box.setTexture(ts,tex)
##        #список боксов
##        #list of boxes
##        self.boxes = []
##        #генерим случайные боксы
##        #generate some random boxes
##        for i in range(randint(10, 20)):
##            #генерируем размеры
##            #randomize size
##            sx=(random()+0.5) * 3
##            sy=(random()+0.5) * 3
##            sz=(random()+0.5) * 3
##            #создаём копию загруженного ранее бокса
##            #copy of the basic box
##            boxNP = box.copyTo(render)
##            #устанавливаем случайным образом позицию,
##            #random position,
##            boxNP.setPos(randint(-40, 40), randint(-40, 40), 20 + randint(0,20))
##            #цвет
##            #color
##            boxNP.setColor(random()*2, random()*2, random()*2, 1)
##            #и ориентацию в пространстве
##            #and orientation
##            boxNP.setHpr(randint(-45, 45), randint(-45, 45), randint(-45, 45))
##            #устанавливаем размер сгенеренный ранее
##            #set size
##            boxNP.setScale(sx,sy,sz)
##            #Настроим физическое тело для наших боксов
##            #Set physic body for our box
##            boxBody = OdeBody(self.world)
##            M = OdeMass()
##            M.setBox(1.5, 1, 1, 1)
##            boxBody.setMass(M)
##            #и синхронизируем их положение с нашими визуальными телами
##            #sync box and body position and orientation
##            boxBody.setPosition(boxNP.getPos(render))
##            boxBody.setQuaternion(boxNP.getQuat(render))
##            #настроим физическую геометрию для наших физических тел
##            #set ODE geometry for body. Panda's visual geometry-mesh and 
##            #ODE geometry is different things
##            boxGeom = OdeBoxGeom(self.space, sx,sy,sz)
##            boxGeom.setBody(boxBody)
##            #В завершение, внесём наше физическое и визуальное тело в список
##            #это потребуется в дальнейшем что б их синхронизировать
##            # Add box and body to list for use later
##            self.boxes.append((boxNP, boxBody))

        self.groundGeom = OdePlaneGeom(self.space, Vec4(0, 0, 1, 0))
        
        self.cars=[]
##        #Ограждение для трассы
##        #the border for the road
##        b1 = loader.loadModel('res/models/border')
##        b1.setScale(8)
##        b1.flattenStrong()  #применим трансформацию перед считыванием инфы для создания ОДЕ геометрии
##                            #apply transform before read vertex info for create ODE geometry
##        b1Trimesh = OdeTriMeshData(b1)
##        self.b1Geom = OdeTriMeshGeom(self.space, b1Trimesh)
##        self.space.setSurfaceType(self.b1Geom, 3)
##        b1.reparentTo(render)        
##        #Наш бордюр должен отталкивать машину и боксы, но не должен коллидиться с трассой
##        #Our border must collide with the box and car, but never with the road
##        self.b1Geom.setCollideBits(BitMask32(0x00000002))
##        self.b1Geom.setCategoryBits(BitMask32.allOff())
##        
##        #Трассу загружаем аналогично бордюру
##        #Load the road similar the border
##        road = loader.loadModel('res/models/track')
##        road.setScale(8)
##        road.flattenLight() 
##        roadTrimesh = OdeTriMeshData(road, False)
##        self.roadGeom = OdeTriMeshGeom(self.space, roadTrimesh)
##        road.reparentTo(render)
##        self.roadGeom.setCollideBits(BitMask32(0x00000002))
##        self.roadGeom.setCategoryBits(BitMask32.allOff())      
##        render.ls()
##        #машина/car
##        self.car=Car(self.world,self.space,Vec3(0,0,5),"test")
##        #AI-test
##        self.testAIcars=[]
##        sampleAI=AI(render)
##        for i in xrange(3):
##            self.testAIcars.append(baseCar(self.world,self.space,
##                                    Vec3(randint(-25,25),randint(-15,15),5),
##                                    "testAI"+str(len(self.testAIcars))))        
##            sampleAI.addCar(self.testAIcars[len(self.testAIcars)-1])
        base.disableMouse()
        #effects
        #self.eff=MotionTrails()
        #Добавляем симуляцию в менеджер задач/add simulation to the task manager
        taskMgr.doMethodLater(0.5, self.simulationTask, "Physics Simulation")
        #PStatClient.connect()
    
    #процедура симуляции/simulation procedure
    def simulationTask(self,task):
        iterations = 4
        #ограничиваем максимальное время чтоб не получить взрыв при подвисании
        #We limit the maximum time not to receive explosion of physic system if application stuck
        dt=globalClock.getDt()
        if dt>0.02: dt=0.02
        dt=dt / iterations * 3.5
        
        #Some iterations for the more stable simulation
        #несколько проходов для более стабильной симуляции
        for i in xrange(iterations):
          self.world.quickStep(dt)
          cc=self.space.autoCollide()
        #Синхронизируем визуальные тела панды с физическими ОДЕ
        #Sync the box with the bodies
##        for np, body in self.boxes:
##            np.setPos(render, body.getPosition())
##            np.setQuat(render,Quat(body.getQuaternion()))        
        self.contactgroup.empty() #Очищаем контакты перед следующим шагом симуляции/clear contacts before next step        
##        self.car.Sync()#синхронизируем машину/sync the car
##        for AIcar in self.testAIcars:
##            AIcar.Sync()
        for car in self.cars:
            car.Sync()
        return task.cont
